package org.jeecg.modules.stm.metric.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
 
 
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.jeecg.modules.stm.metric.entity.MetricStatSet;
import org.jeecg.modules.stm.metric.service.IMetricStatSetService;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: 监测报告配置
 * @Author: jeecg-boot
 * @Date:   2024-01-04
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/metric/metricStatSet")
@Slf4j
public class MetricStatSetController extends JeecgController<MetricStatSet, IMetricStatSetService> {
	@Autowired
	private IMetricStatSetService metricStatSetService;
	
	/**
	 * 分页列表查询
	 *
	 * @param metricStatSet
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "监测报告配置-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<MetricStatSet>> queryPageList(MetricStatSet metricStatSet,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<MetricStatSet> queryWrapper = QueryGenerator.initQueryWrapper(metricStatSet, req.getParameterMap());
		Page<MetricStatSet> page = new Page<MetricStatSet>(pageNo, pageSize);
		IPage<MetricStatSet> pageList = metricStatSetService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param metricStatSet
	 * @return
	 */
	@AutoLog(value = "监测报告配置-添加")
	  
	@RequiresPermissions("metric:metric_stat_set:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody MetricStatSet metricStatSet) {
		metricStatSetService.save(metricStatSet);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param metricStatSet
	 * @return
	 */
	@AutoLog(value = "监测报告配置-编辑")
	  
	@RequiresPermissions("metric:metric_stat_set:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody MetricStatSet metricStatSet) {
		metricStatSetService.updateById(metricStatSet);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "监测报告配置-通过id删除")
	  
	@RequiresPermissions("metric:metric_stat_set:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		metricStatSetService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "监测报告配置-批量删除")
	  
	@RequiresPermissions("metric:metric_stat_set:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.metricStatSetService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "监测报告配置-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<MetricStatSet> queryById(@RequestParam(name="id",required=true) String id) {
		MetricStatSet metricStatSet = metricStatSetService.getById(id);
		if(metricStatSet==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(metricStatSet);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param metricStatSet
    */
    @RequiresPermissions("metric:metric_stat_set:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, MetricStatSet metricStatSet) {
        return super.exportXls(request, metricStatSet, MetricStatSet.class, "监测报告配置");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("metric:metric_stat_set:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, MetricStatSet.class);
    }

}
